\ Application control file for RTXUF Monitor 1.00
pto

\ Configure cross compiler 

\ Hex 0320 Emu-Base                     \ Set I/O address
\ e27512 16bit output-emulator          \ Type and Bus Width

\ Configure cross compiler for appropriate RTX processor type
all from-file rtx2000.def		\ configure for processor

only forth definitions			\ initial host search order

CROSS-COMPILE				\ turn compiler on

ALIGN					\ word aligned data
no-heads				\ no dictionary headers
\ tail-opt				\ switch on tail optimiser
no-optimize

only forth definitions                  \ initial target search order

\ memory layout

hex
rom-target				\ generate a ROM target

08100 090FF kernel APP2000              \ 4K - increase if app bigger!
0c000 0ffff 0 data-page kernel-data

use-code APP2000
use-data kernel-data

\ interrupt handler equates

$A000 constant int-base			\ this must be on a 1K boundary 
					\ but it can move

$8000 equ clock-khz			\ used to define how long a second is
					\ in the interrupt example

\ kernel files and application

decimal all from-file drivers\MONIO	\ monitor i/o hooks
decimal all from-file CODE2000		\ forth support code
decimal all from-file kernel		\   "      "     "

decimal all from-file vectors.fth
decimal all from-file interupt.fth
decimal all from-file examples\ints.fth

\ run umbilical cord

only forth definitions			\ final search order
decimal

umbilical-forth				\ start Umbilical Forth
