((

	HEADER.FTH

	J Lee :- 22/6/90

	Copyright (C) 1983-1991

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	This file contains code that defines the header section of chunks
	in a page.

))



only forth also c-c definitions

\ @(v) !(v) c@(v) c!(v) 2!(v) 2@(v) .. J Lee -- 24/06/90
\


: @(v)	( offset -- n )
	voc-seg@  swap  @l  ;


: !(v)	( n offset -- )
	voc-seg@  swap  !l  ;                  


: c@(v)	( offset -- c )
	voc-seg@  swap  c@l  ;


: c!(v)	( c offset -- )
	voc-seg@  swap  c!l  ;


: 2!(v)	( d offset -- )
	voc-seg@ swap 2!l  ;


: 2@(v)	( offset -- d )
	voc-seg@ swap 2@l  ;




\ @(p)l !(p)l c@(p)l c!(p)l 2@(p)l 2!(p)l .. J Lee -- 26/06/90
\
							   

: @(p)l	( seg offset -- n )
	@l  ;


: !(p)l	( n seg offset -- )
	!l  ;                  


: c@(p)l	( seg offset -- c )
	c@l  ;


: c!(p)l	( c seg offset -- )
	c!l  ;


: 2@(p)l	( seg offset -- d )
	2@l  ;


: 2!(p)l	( d seg offset -- )
	2!l  ;




\ On(v) Off(v) +!(v) .. J Lee -- 22/06/90
\

: On(v)	( offset -- )
	-1 swap !(v)  ;


: Off(v)	( offset -- )
	0 swap !(v)  ;


: +!(v)	( n offset -- )
	dup @(v)  rot +  swap !(v)  ;




\ @(c) !(c) c@(c) c!(c) 2!(c) 2@(c) +!(c) .. J Lee -- 24/06/90
\
\ These words all access the latest chunk in a vocabulary chunk chain


: @(c)	( offset -- n )
	voc-seg@ latest-chunk @l  swap  @l  ;


: !(c)	( n offset -- )
	voc-seg@ latest-chunk @l  swap  !l  ;                  


: c@(c)	( offset -- c )
	voc-seg@ latest-chunk @l  swap  c@l  ;


: c!(c)	( c offset -- )
	voc-seg@ latest-chunk @l  swap  c!l  ;


: 2!(c)	( d offset -- )
	voc-seg@ latest-chunk @l  swap 2!l  ;


: 2@(c)	( offset -- d )
	voc-seg@ latest-chunk @l  swap 2@l  ;


: +!(c)	( n offset -- )
	dup @(c)  rot +  swap !(c)  ;




\ Test code .. J Lee -- 24/06/90
\


\ : .Page	( -- )
\	voc-seg@ >es
\	{Page-Management
\	}Page-Management {Page-Management -
\	edump  ;


\ : .Page-Free	( -- )
\	cr ." Free Page Space:  "
\	}Page-Management Page-Addr @ - u.
\	." bytes"  ;






























