((
	GLOBAL.FTH

	J Lee :- 22/6/90

        Copyright (C) 1983-91

	MicroProcessor Engineering Ltd
	133/133a Hill Lane
	Southampton
	SO1 5AF

	tele:	(0703) 631441
	inter:	+44 703 631441


	This file contains code that describes and reads/writes the XCompiler
	Global data.

))



only forth also c-c definitions
decimal


\ {Global-Managment }Global-Management .. J Lee -- 22/06/90
\


decimal

Create  {Global-Management
	here  1000 allot  1000 erase            \ Claim space in XCompiler
	here Constant }Global-Management



\ @(g) !(g) c@(g) c!(g) 2!(g) 2@(g) .. J Lee -- 24/06/90
\


: @(g)	( addr -- n )
	@  ;


: !(g)	( n addr -- )
	!  ;                  


: c@(g)	( addr -- c )
	c@  ;


: c!(g)	( c addr -- )
	c!  ;


: 2!(g)	( d addr -- )
	2!  ;


: 2@(g)	( addr -- d )
	2@  ;




\ On(g) Off(g) +!(g) .. J Lee -- 22/06/90
\


: On(g)	( addr -- )
	-1 swap !(g)  ;


: Off(g)	( addr -- )
	0 swap !(g)  ;


: +!(g)	( n addr -- )
	 dup @(g) rot + swap !(g)  ;




\ Test-Bit(g) Set-Bit(g) .. J Lee -- 29/1/91
\


: Test-Bit(g)  ( mask addr -- b )
  @(g) AND  ;


: Set-Bit(g)  ( mask addr -- )
  dup @(g)  rot OR  swap !(g)  ;



\ Global-Addr Global-Addr@ Global-Lab .. J Lee -- 22/06/90
\


decimal

Variable Global-Addr                \ use only by building
                                    \ words
{Global-Management Global-Addr !


: Global-Addr@	( -- n )
	Global-Addr @  ;


: Global-lab	( -- )
	Global-addr@ constant  ;



\ Global-var ?Global-Addr.. J Lee -- 22/06/90
\

decimal

: ?Global-Addr	( -- )
	Global-addr@ }Global-Management 10 - u>   \ Enough space?
	abort" Out of Global Management space"  ;     \  error if not


: Global-Var                                \ -- [Parent]
	?Global-addr                            \ -- addr [Chd]
	Global-addr@ constant
	cell Global-addr +!  ;


\ Allot(g) .. J Lee -- 22/06/90
\

: Allot(g)	( n -- )
	Global-Addr +!
	?Global-addr  ;



\ ,(g) c,(g) .. J Lee -- 22/06/90
\

: ,(g)	( n -- )
	Global-Addr@ !(g)
	cell Global-Addr +!
	?Global-addr  ;


: C,(g)	( c -- )
	Global-Addr@ c!(g)
	1 Global-Addr +!
	?Global-addr  ;



\ Start mapping Global management space .. J Lee -- 24/06/90
\


decimal

Global-lab Rfu(g) 32 allot(g)	\ RFU  [ 32 bytes ]
Global-lab Int(g) 32 allot(g)	\ Internal [ 32 bytes ]
Global-var State(t)			\ State of target
Global-var Curr-Code-Page		\ Current code page's symbol page
Global-var Curr-Data-Page		\ Current data page's symbol page
Global-var Kernel-Ram-Page              \ symbol page for initialised RAM
Global-var Host-Mode			\ True for normal compiler
Global-var Sb#				\
Global-var Ram-Area			\
Global-var Ram-Size			\
Global-var Curr-Ram-Size	        \ current size of RAM table
Global-var ?Rom				\
Global-var ?Log				\
Global-var Fence(t)			\
Global-var Curr				\
Global-var Common-Ram(t)		\ set if WORK-BASE used
Global-var #Lines				\
Global-var All-Res				\
Global-var LogOut				\
Global-var Emulator-Out			\
Global-var ?Aligning			\
Global-var ?Bounding			\
Global-var Cont				\
Global-var Next-Prom			\
Global-var Min-Space			\
Global-var Prom-Size			\
Global-var Prom-Offset			\
Global-var Fill-Byte			\ character to fill empty file with
Global-var Width(t)			\ Target width
Global-var Ref1				\ Forward ref#1
Global-var Ref1-Seg			\ Forward ref#1 segment
Global-var Ref2				\ Forward ref#2
Global-var Ref2-Seg			\ Forward ref#2 segment
Global-var Ref-Seg				\ Forward reference segment for FORWARD-SET
Global-var Voc-Link(t)			\ Voc-Link for target
Global-var Do-Build			\ Flag compile-in-host
Global-var ?Smudge				\
Global-var #Logged				\
Global-var #forward			\ number of forward refs.
Global-var Symbols-allocated		\ TRUE if symbol space in use
Global-var Data-Search			\ TRUE if data pages are to be searched
Global-var is-data-page                 \ TRUE if page being loaded is a data page

Global-lab 'Equates(s)			\ Voc symbol address
		dcell(s) allot(g)

Global-lab 'Labels(s)			\ Voc symbol address
		dcell(s) allot(g)

Global-lab 'Forth(s)			\ Voc symbol address
		dcell(s) allot(g)

\ Global-var 'Page(s)			\ Voc symbol address

Global-lab 'Root(s)			\ Voc symbol address
		dcell(s) allot(g)

Global-lab Cont(s)				\ storage for voc env.
		dcell(s) allot(g)

Global-lab Curr(s)				\
		dcell(s) allot(g)

Global-var State_Flag			\ used by SMC code
							\ 1 == State Compiler on
							\ 2 ==   "       "    " and forward refs


Global-var In-Umbilical			\ flag whether in Umbilical mode or not


Global-var Debug				\ flag used when debugging compiler

Global-var Code-Page-Open	\ flag whether any code page is open := TRUE

Global-lab Emu-Offset                   \ emulator offset
        4 allot(g)                      \   double number
 
Global-var Curr-Page                    \ storage for Curr-Page
Global-var Old-Curr-Page
Global-lab Page-Table                   \ Page table for segments of symbol pages
	#Pages /Page-Record * allot(g)

global-var Cfa-Addr		        \ address to search for   - DASM
global-var Cfa-Name		        \ seg and offset for name - DASM
	cell allot(g)







\ Voc-Seg Voc-Seg! Voc-Seg@ .. J Lee -- 02/07/90
\


global-var Voc-Seg	\ pointer to base chunk of vocabulary in use
global-var Old-Voc-Seg	\ storage for voc-seg
global-var Global-Voc-Seg	\ SUSPEND for buffer for VOC-SEG


: Voc-Seg!	( seg -- )
	Voc-Seg !(g)  ;


: Voc-Seg@	( -- seg )
	Voc-Seg @(g)  ;




\ Test code .. J Lee -- 24/06/90
\


\ : .Global	( -- )
\	{Global-Management
\	}Global-Management {Global-Management -
\	dump  ;


\ : .Global-Free	( -- )
\	cr ." Free Global Space:  "
\	}Global-Management Global-Addr @ - u.
\	." bytes"  ;







