\ Harris RTXDB board monitor control file.
pto

Author: J lee

Date started:   12/04/90
Last modified:  25/05/93

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF

tel (+44) 703 631441

\ Compiler Directives for RTX Umbilical Forth ....  \  12/04/90
\ Configure compiler to appropriate processor

only forth definitions

\ Hex 0320 Emu-Base                     \ Set I/O address
\ e27512 16bit output-emulator          \ Type and Bus Width

decimal	      

all from-file rtx2000.def		\ processor specifics

CROSS-COMPILE				\ turn compiler on

ALIGN					\ word aligned

\ no-log				\ no progress log
no-heads				\ header-less

only forth definitions			\ initial search order

\ memory layout
Hex

ROM-TARGET
0 equ RAM-PAGE

00000 0fff kernel RTXDBMON			\ Start of ROM
08000 0ffff RAM-PAGE Data-Page Monitor-Data	\ Start of RAM

use-code RTXDBMON
use-data Monitor-data

\ pull in the required files

decimal all from-file MONITOR			\ Entry points
decimal all from-file drivers\RTXDBIO		\ RTXDB UART i/o drivers
decimal all from-file SUPPORT			\ required Forth support
decimal all from-file STAK2000			\ SP@ SP! DEPTH
decimal all from-file MESSAGES			\ message numbers
decimal all from-file drivers\MONIO		\ Monitor I/O drivers
decimal all from-file TARGEND			\ Umbilical Forth target end

make-turnkey kick-off			       

FINIS


