((
        MONITOR.FTH

        Author: J Lee

        Date started:   1990
        Last modified:  23/11/92

        RTXDS Monitor File.

        Copyright (c) 1989, 1990
        MicroProcessor Engineering Ltd.
        133 Hill Lane
        Southampton SO1 5AF
        England

        tel: (+44) 703 631441
))



\ memory allocation (in hex):
\
\ 00000 - 001ff : Reset and interrupt vector table
\ 00200 - 0020f : Unused (RTX interrupt bug)
\ 00210 - 00213 : Entry point for monitor services
\ 00214 - ????? : Monitor and Message-Passer



only forth definitions

\ Reset vector and interrupt vectors ......        Jon 19/12/89
\

] startup Exit   startup Exit [		\ cold and warm entry

0200 org				\ skip interrupt area
] Exit [				\ lay EXIT code for phantom interrupt



\ Skip area where interrupt bug exists ....        Jon 08/12/89
\
\ Monitor services entry point ............        Jon 11/12/89
\ at address: 0210(hex)

hex
0210 org				\ monitor entry point


\
\ Force forward reference to actual code
\
] I/O-Service   Exit [


\
\ Modify this string when upgrading versions
\
create Version$  ",   V1.00"
			

\ entry point that make-turnkey patches 

l: strt 0 ,				\ patch this with a "make-turnkey"
					\ later
: Startup	\ -- ; run startup code
  0 spr!				\ initial stack pointers
  (init)				\ initialise Forth
  STRT @ Execute			\ run application
;
