\ RTX-2000 Target Code                               sfp 20/04/90

pto

Released for use with the MPE Forth Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

\ Misc equates ....................................Rod 15/12/87

hex

only forth definitions

0 Equ False
-1 Equ True
020 Equ Task-Len

decimal

\ release numbers                                J Lee 27/09/91
Decimal

3 equ Rel-Code				\ release
0 equ Ver-code				\ minor version
0 equ Bug-Code				\ bug fix level

Rel-Code 100 *  Ver-Code 10 * +  Bug-Code +
equ Version#

Rel-Code Ascii 0 + Equ Mpe-Rel		\ ASCII equivalents
Ver-Code Ascii 0 + Equ Mpe-Ver
Bug-Code Ascii 0 + Equ Mpe-Bug

\ Start up table - system addresses ...............sfp 12/04/90

hex

] Startup Exit [ 			\ Cold start point
] Warm Exit [				\ Warm start point

0220 org				\ skip interrupt area *****

L: Ramsize      EM ,
L: Ver#         Version# ,		\ version number

Decimal

L: cpu-clock    clock-khz 1000 um* , ,	\ clock in Hz
L: baud-rate    serial-baud ,		\ required baud rate

\ set CYCEXT bit in IBC if TCLK > 8Mhz
Int-Base 
clock-khz 8000 u>  
if( 
  $0080 or 
)endif  
equ init-IBC


\ main tcb, user & TIB buffer allocation           sfp 01/09/90

hex

0 Constant Main  -2 Allot		\ tcb header

Here 2 + ,  0 ,				\ data-addr & link field
Task-Len Allot				\ data area

L: Init-U0   Us Allot			\ user area
L: Init-Tib  080 Allot			\ terminal input buffer

decimal

\ start-up values ................................ RTX 14/04/88
hex

L: Init-Fence 0 ,			\ fence
L: Init-Dp 0 ,				\ dp
L: Init-Voc-Link 0 ,			\ voc-link

decimal

\ serial number and copyright messages ........... sfp 20/04/90

L: Serial#      0 ,
L: Copyright
", Copyright (C) 1988-1993 Microprocessor Engineering"

\ System variables                                  \  20/11/90
hex

Variable Fence				\ dictionary marker
Variable DP				\ top of Dictionary
Variable Voc-Link			\ Vocabulary Chain
Variable BLK				\ requested disk block
Variable State				\ compilation state
Variable CSP				\ compilation check
Variable Done-Flg			\ true when input run out
Variable User-Base			\ Pointer to user area
  Init-U0 User-Base !
Variable Lit-Count			\ temp for #literal
Variable Optimising			\ Optimisation control
Variable 'Last				\       "         "
Variable Current			\ Compilation Voc
Create Context 010 Allot		\ Search Vocs

Variable #Threads			\ for a new vocabulary
Variable Last				\ last NFA address
variable xon/xoff			\ true if in use
variable echoing    -1 echoing !	\ true if echoing

\ user variables                                    \  20/11/90
hex

02 User S0          04 User R0
06 User 'Tib        08 User Width
0A User >In         0C User Out
0E User Scr         10 User Span
12 User Hld         14 User Base
18 User Dpl         1A User #Tib
1C User #L          1E User Tab-Width
20 User #D          22 User Line#
24 User Page#
40 User Pad
