\ dumpl

hex

variable dump-page

: dumpl		\ addr page len --
  swap dump-page !			\ save page
  BOUNDS                                \ get limits
  ?DO
    CR  dump-page @ .word  ascii : emit  I .WORD	\ print address
    I					\ start address of line
    010 0
    do
      i 7 and 0<> 2+ spaces		\ space every eight
      dup i + dump-page @ c@l .BYTE	\ print byte
    loop
    drop
    2 SPACES  				\ gap
    I 010 bounds
    DO
      I dump-page @ c@l .ASCII		\ ascii o/p
    LOOP
    HALT? ?LEAVE			\ quit or halt
  010 +LOOP                             \ until done
  CR
;

: filll		\ addr page len char --
  rot dump-page !
  -Rot Bounds
  ?DO
    Dup I dump-page @ C!l
  LOOP
  Drop
;

: d		\ -- ; display start of dual port RAM
  0 1 0120 dumpl  ;

\ dual port RAM test routines

variable offset		\ offset into DPRAM

: c>b		\ char -- ; put char in buffer
  offset @ 1 c!l			\ put character in buffer
  1 offset +!
;

cr ." all done"

