\ RTX-2000 Startup Code                               RTX 21/04/88
pto

Released for use with the MPE/Nautilus Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: (+44) 703 631441
fax: (+44) 703 339691

\ Misc equates ....................................Rod 15/12/87
HEX					\

only forth definitions

0 Equ False				\
-1 Equ True				\
020 Equ Task-Len			\

DECIMAL					\

\ release numbers                                J Lee 26/11/92
decimal

3 equ rel-code				\ release
0 equ ver-code				\ minor version
0 equ bug-code				\ bug fix level

rel-code 100 *  ver-code 10 * +  bug-code +
equ version#

rel-code ascii 0 + equ mpe-rel		\ ASCII equivalents
ver-code ascii 0 + equ mpe-ver
bug-code ascii 0 + equ mpe-bug

\ Start up table - system addresses ............... \  19/11/90
HEX					\

] Startup Exit [ 			\ Cold start point
] Warm Exit [				\ Warm start point

0220 org				\ skip interrupt area *****

L: Ramsize      EM ,			\
L: Ver#         Version# ,		\ version number

Decimal

L: cpu-clock    clock-khz 1000 um* , ,	\ clock in Hz
L: baud-rate    serial-baud ,		\ required baud rate

\ set CYCEXT bit in IBC if TCLK > 8Mhz
Int-Base 
clock-khz 8000 u>  
if( 
  $0080 or 
)endif  
equ init-IBC

\ main tcb, user & disk buffer allocation ........ sfp 03/09/90
HEX					\

There Constant Main			\ tcb header

0 ,(r)					\ data-addr & link field
Task-Len Allot-ram			\ data area

There Equ Init-U0   Us Allot-ram	\ base of user area
There Equ Init-Tib  128 Allot-ram	\ keyboard buffer

DECIMAL					\

\ start-up values ................................ RTX 14/04/88
HEX					\

L: Init-Fence 0 ,			\ fence
L: Init-Dp 0 ,				\ dp
L: Init-Voc-Link 0 ,			\ voc-link

DECIMAL					\

\ serial number and copyright messages ........... sfp 12/04/90

L: Serial#      0 ,			\
L: Copyright				\
", Copyright (C) 1988-1993 Microprocessor Engineering"

\ System variables                                 Jon 10/07/89
hex

Variable Fence				\ dictionary marker
Variable DP				\ top of Dictionary
Variable Voc-Link			\ Vocabulary Chain
Variable BLK				\ requested disk block
Variable State				\ compilation state
Variable CSP				\ compilation check
Variable Done-Flg			\ true when input run out
Variable User-Base			\ Pointer to user area
\  Init-U0 User-Base !
Variable Lit-Count			\ temp for #literal
Variable Optimising			\ Optimisation control
Variable 'Last				\       "         "
Variable Current			\ Compilation Voc
Variable Context 0E allot-ram		\ Search Vocs

Variable #Threads			\ for a new vocabulary
Variable Last				\ last NFA address
variable xon/xoff			\ true if in use
variable echoing			\ -1 echoing !        \ true if echoing

\ user variables                                   sfp 13/04/88
HEX					\

02 User S0          04 User R0		\
06 User 'Tib        08 User Width	\
0A User >In         0C User Out		\
0E User Scr         10 User Span	\
12 User Hld         14 User Base	\
18 User Dpl         1A User #Tib	\
1C User #L          1E User Tab-Width	\
20 User #D          22 User Line#	\
24 User Page#				\
40 User Pad				\


