\ ROM Forth Intel Hex file upload tool               sfp 15/05/88
pto

Copyright (c) 1988  MicroProcessor Engineering

Released for use with the MPE/Nautilus Cross Compiler by:

MicroProcessor Engineering
133 Hill Lane
Shirley
Southampton SO1 5AF
England

tel: 0703 631441        (inside U.K.)
     (+44) 703 631441   (international)

\ Intel hex down loader - converts given file      sfp 16/05/88
internal
HEX

010  constant line-length

variable CHECKSUM
variable RECORD
variable LENGTH
variable MEM-ADDRESS

\ Intel hex down loader  ..................        sfp 15/05/88

: CHAR-TARGET	                \ char --
  ser-key?
  IF
    ser-key XOFF =
    IF
      BEGIN
        ser-key XON =
      UNTIL
    ENDIF
  ENDIF
  ser-emit  
;

: REM-CR	                \ -- ; crlf to remote
  0D CHAR-TARGET  0A CHAR-TARGET  
;

\ Intel hex down loader  ..................        sfp 15/05/88

: BIN-ASCII	                \ n -- ascii
  0F AND  DUP 9 >
  IF
    037
  ELSE
    030
  ENDIF
  +  
;

: byte-ascii	                \ byte -- l-char h-char
  DUP BIN-ASCII  SWAP 010 /  BIN-ASCII  
;

\  Intel hex down loader  ................         sfp 15/05/88
( byte --- )

: BYTE-TARGET 
  0FF AND  DUP checksum +!
  BYTE-ASCII CHAR-TARGET CHAR-TARGET  
;

: hex-HEADER 
  03A CHAR-TARGET  CHECKSUM off  
;

: RECORD-LENGTH
  LENGTH @ BYTE-TARGET  
;

: START-ADDRESS 
  MEM-ADDRESS @ 0 0100 um/mod
  BYTE-TARGET  BYTE-TARGET  
;

: TYPE-OF-RECORD
  RECORD @ BYTE-TARGET  
;

\ Intel hex down loader  .................         sfp 12/09/89

: DATA
  Mem-Address @  LENGTH @  bounds
  ?DO
    I c@ BYTE-TARGET
  LOOP
;

: SEND-CHECK    
  CHECKSUM @ negate BYTE-TARGET
  CHECKSUM off  
;

: SEND-RECORD
  hex-HEADER RECORD-LENGTH START-ADDRESS
  TYPE-OF-RECORD DATA SEND-CHECK REM-CR  
;

: SEND-LAST-RECORD
  LENGTH off 1 RECORD !
  SEND-RECORD 0 RECORD !  
;

\ User-Start? ?User-finish .............           sfp 07/04/89
decimal					\

: ?User-Start	                \ --
  cr ." Start ASCII receiver - [PgDn],7 with ProComm"
  cr ." then press SPACE-BAR" cr			\
  BEGIN
    key BL =
  UNTIL					\
;					\

: ?User-Finish	                \ --
  BEGIN
    key 13 =
  UNTIL					\
  cr ." File Transfer Successful" cr	\
;					\

\ Intel hex down loader  ...............           sfp 16/05/88
External				\

: HEX-DOWN	                \ addr #bytes --
  ?User-Start				\ Down-Load started ?
  swap MEM-ADDRESS !			\ Upload from addr.
  line-length LENGTH !			\
  0					\
  ?DO
    SEND-RECORD				\
    length @ dup			\ line length in CELLS
    MEM-ADDRESS +!			\ update address and cou
  +LOOP					\
  send-last-record			\
  ?User-Finish				\ Down-Load finished ?
;

