((

	DIS-EXTN.FTH

	MPE Forth Cross Compiler v5.00

	J Lee - 9/7/90


	Copyright (C) 1983-1991

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)

	Extend the cross compiler for decompiler

))



only forth also c-c definitions
decimal



\ Cfa>Name .. J Lee -- 30/10/90
\

: Cfa-Search-Thread	( seg thread -- t/f )
	swap >r		\ preserve segment
	Begin
		r@ swap @(s)l dup	\ follow specific thread link
	While
		r@ swap
		2dup name>(s) cell(s)+ @(s)l	\ has this symbol the correct CFA?
		Cfa-Addr @(g) =
		If
			Cfa-Name 2!(g)		\ y:  save symbol address
			r> drop			\     and exit this search
			TRUE EXIT
		Endif
		cell(s)- nip
	Repeat
	r> drop  ;


: Cfa-Search-Chunk	( chunk -- t/f )
	FALSE swap			\ assume failue
	chunk-threads #threads(s) cell(s)* bounds	\ for all threads:
	?Do
		dup i cfa-search-thread	\ search specific thread
		If
			swap NOT swap 		\ set flag to TRUE		
			LEAVE			\ leave if CFA found
		Endif
		2
	+Loop
	drop  ;


: Cfa-Search-Voc	( voc-seg -- t/f )
	latest-chunk			\ start with last chunk in chain
	Begin
		@(s)l dup			\ follow through chunks
	While
		dup cfa-search-chunk ?dup	\ search each chunk in turn
		If
			nip EXIT		\ EXIT if found
		Endif
		<chunk-link
	Repeat  ;


: Cfa-Search-Page	( -- t/f )
	<voc-link(s) 2@(p)		\ search all vocs though voc-link
	Begin
		2dup or 0<>
	While
		2dup <voc-link(s)- voc-chunk+ @(s)l cfa-search-voc  ?dup
		If
			-rot 2drop EXIT
		Endif
		2@(s)l
	Repeat
	2drop FALSE  ;



: Cfa>Name	( cfa -- seg off t/f )
	cfa-addr !(g)			\ set initial pars.
	0,0 cfa-name 2!(g)
	cfa-search-page		\ search for CFA
	cfa-name 2@(g) 		\ return name
	rot  ; public		\ and bring flag to top

