((

	XDTC50-2

	MPE Forth Cross Compiler v5.00

	J Lee - 9/7/90


	Copyright (C) 1983-1991

	MicroProcessor Engineering
	133 Hill Lane
	Southampton
	SO1 5AF
	England

	tel: (+44) 703 631441   (international)
	tel: 0703-631441        (domestic)

))




\ Start of Cross Compiler .. Jon 11/01/89
\


only forth also c-c definitions




\ Loading initiation .. sfp 21/02/90
\


decimal

: .Version	( -- )
	." MPE Forth Cross Compiler v5.200"  ;


: .Symbol-Space	( -- )
	?symbol-space 
	16 um*
	." Free symbol space: "
	base @ >r  decimal d.  r> base !  ." bytes"  ;


: NccLogo	( -- )
	cr
	cr .version
	cr .target
	cr ." Copyright (C) 1990-2000  MicroProcessor Engineering"
	cr .symbol-space
	cr  ;




\ y/n? .. Jon 22/08/88
\


: y/n?	( -- t/f ; y = true )
	key upc ascii Y =
	dup
	If
		ascii Y
	Else
		ascii N
	Endif
	emit  ;




\ Log to disk words .. sfp 21/02/90
\


pcb LOG.PCB					\ logged file pcb and
"" LOG.TXT" Log.Pcb set-pathname	\ default filename


: Open-Log	( -- ; open log file according to type )
	Case  logout @(g)						\ test type
		1	Of   printer  Endof			\ printer
		2	Of   Log.Pcb create-path-pcb		\ file
				If
					." Can't open: " Log.Pcb .pcb  abort
				Endif
				Log.Pcb handle op-handle !	\ set log output han
			Endof
	Endcase  ;




\ close-log .. sfp 21/02/90
\


: Close-Log	( -- ; close log according to type )
	Case  Logout @(g)					\ test log type
		2	Of Log.Pcb handle close-path	\ file, so close it
				If
					console			\ error checking
					." Can't close: " Log.Pcb .pcb
				Endif
			Endof
	Endcase
	console
	logout off(g)  ;
\	0 op-handle !  ;			\ and back to cons.




\ log switches .. Jon 07/02/89
\


only forth also c-c also forth definitions


: File	( -- )
	cr ." Symbol log file is " log.pcb .pcb cr
	2 LogOut !(g)  ;						\ LogOut := FILE


: File:	( -- ; <FileName> )
	bl word dup count upper  dup c@	\ file name specified ?
	If
		Log.Pcb set-pathname		\ Y: set file name
	Else
		 drop					\ N: use default
	Endif
	file  ;						\ set LogOut for file




\ Log switches .. Jon 07/02/89
\


: Prn:	( -- )
	cr ." Printing symbol log ... " cr
	1 LogOut !(g)  ;			\ LogOut := PRINTER                                      \


: Con:	( -- )
	0 LogOut !(g)  ;			\ LogOut := CONSOLE


only forth also c-c definitions


: Log	( -- )
	?Log on(g)  ;


: No-Log	( -- )
	?Log off(g)  ;        




\ align[h] even[h] .. sfp 24/03/87
\


0 Constant Align(h)	\ true for word aligned processors


: Even(h)	( -- )
	Align(h)			\ align mode set?
	If				\ y:
		here 1 and	\	odd address?
		If			\	y:
			bl c,	\		lay an extra 'space' character
		Endif
	Endif  ;




\ lay: .. sfp 15/08/88
\


hex

	cr cr	.( DTC host: 8086 version of lay: )
	cr


' .version 1+ @  ' .version 3 + + constant run-colon

: Lay:
	0e9 c,					\ lay jmp opcode
	run-colon here - 2- ,  ;		\ lay offset


	cr cr	.( End of HOST dependent words.. )
	cr


\ hex
\
\
\	cr cr	.( ITC host: generic version of lay: )
\	cr
\
\
\ : Lay:
\	[ ' .version @ ] literal ,  ;
\
\
\	cr cr	.( End of HOST dependent words.. )
\	cr




\ Octal $Here target-Compilation .. sfp 14/04/89
\


hex


: Octal	( -- ; set number base to Octal )
	8 Base !  ;


: $Here=	( $addr -- t/f )
	here here c@ 1+ s=  ;		\ string at HERE


also forth definitions


: Target-Compilation	( -- ; DIRECTIVE )
  Host-Mode off(g)  ;


previous definitions




\ Zero, Zeros, .. Jon 05/01/89
\


hex

: Zero,	( -- )
	0 ,  ;


: Zeros,	( n -- )
	0 ?Do zero, Loop ;




\ Vocabularies .. Jon 09/08/88
\


hex

	cr cr	.( Loading Vocabularies ........ )
	cr

Vocabulary Assembler
Vocabulary Asm-access
Vocabulary Interpreter
Vocabulary Compiler




\ Vocabulary switches  .. sfp 14/04/89
\


	cr cr	.( C-C definitions .... )
	cr



only forth also c-c definitions


: CC/C	( -- )
	Compiler definitions c-c  ;  IMMEDIATE


: CC/I	( -- )
	Interpreter definitions c-c  ;  IMMEDIATE


: CC/A	( -- )
	Assembler definitions c-c  ;  IMMEDIATE


: [+compiler]	( -- )          
	also compiler  ;  IMMEDIATE


: [+interpreter]	( -- )
	also interpreter  ;  IMMEDIATE


: [+assembler]	( -- )
	also assembler  ;  IMMEDIATE


: [+asm-access]	( -- )
	also asm-access  ;  IMMEDIATE


: [previous]	( -- )
	previous  ;  IMMEDIATE


: [definitions]	( -- )
	definitions  ;  IMMEDIATE




\ Constants and variables .. Jon 17/02/89
\


hex

	cr cr	.( Loading Constants ... )
	cr


007 constant Log-Width
050 Log-Width 0b + / constant Log/Line
03d constant L/p


decimal

80 35 - 7 / constant ##S	\ 80 chars wide
						\ 35 chars for name
						\ 7 chars / address



