\ MPE RTX-2000 Powerboard Monitor Control file.
pto

Author: J Lee

Date started:   19/04/90
Last modified:  25/05/93

Copyright (C) 1988-1990 MicroProcessor Engineering

MicroProcessor Engineering
133 Hill Lane
Southampton SO1 5AF
England

tel: (+44) 703 631441

\ Compiler Directives for RTX Umbilical Forth .... sfp 19/04/90

only forth definitions

\ Hex 0320 Emu-Base                     \ Set I/O address
\ e27512 16bit output-emulator          \ Type and Bus Width

decimal

\ Configure compiler to appropriate processor
all from-file rtx2000.def		\ processor specifics

CROSS-COMPILE				\ turn compiler on

ALIGN					\ word aligned
\ no-log				\ no progress log
no-heads				\ header-less
no-optimize

only forth definitions			\ initial search order

\ memory layout
Hex

ROM-TARGET
0 equ RAM-PAGE

00000 0fff kernel P2000-8M		\ Start of ROM
08000 0ffff RAM-PAGE Data-Page Monitor-Data

use-code P2000-8M
use-data Monitor-data			   

\ baud rate calculation                            sfp 19/04/90

decimal

8,000000				\ 8MHz CPU clock
16 mu/mod rot drop			\ divided by 16
38400					\ 38400 baud rate
um/mod nip				\ clock/(16*baud)
0 256 um/mod				\ split into lo/hi
equ ch0-hi-value  equ ch0-lo-value


\ pull in the required files

decimal all from-file MONITOR		\ Entry points
decimal all from-file drivers\MPEPBIO	\ UART i/o drivers
decimal all from-file SUPPORT		\ required Forth support
decimal all from-file STAK2000 		\ SP@ SP! DEPTH
decimal all from-file MESSAGES		\ message numbers
decimal all from-file drivers\MONIO	\ monitor I/O drivers
decimal all from-file TARGEND 		\ Umbilical Forth target end

make-turnkey kick-off
 
FINIS


