((
        MESSAGES.FTH

        Author: J Lee, S Pelc

        Date started:   29/03/88
        Last modified:
                S Pelc  09/90
                Added stack swap messages and stack error messages.


        Umbilical Forth messages file

        Copyright (c) 1988, 1990
        MicroProcessor Engineering
        133 Hill Lane
        Shirley
        Southampton SO1 5AF
        tel: 0703 631441        (inside UK)
             (+44) 703 631441   (international)
))



\ command codes ( to target ) .. Jon 11/12/89
\

hex

001 equ execute-cmnd>t     \ primitive mess
002 equ push-cmnd>t        \ push to target stack
003 equ pop-cmnd>t         \ pop from target stack
004 equ s>t-cmnd>t         \ host stack to target
005 equ s>h-cmnd>t         \ target stack to host
006 equ @-cmnd>t           \ word fetch from target
007 equ !-cmnd>t           \ word store to target
008 equ C@-cmnd>t          \ byte fetch from target
009 equ C!-cmnd>t          \ byte store to target
00A equ L@-cmnd>t          \ long word fetch from target
00B equ L!-cmnd>t          \ long word store to target
00C equ copy-cmnd>t        \ copy image to target
00D equ vers-cmnd>t        \ get target monitor version
00E equ execpr-cmnd>t	\ execute opcode on target




\ command codes ( to host ) .. Jon 11/12/89
\

hex

081 equ key-cmnd>h               \ key command
082 equ emit-cmnd>h              \ emit command
083 equ push-cmnd>h              \ push command
084 equ key?-cmnd>h              \ key? command
085 equ .-cmnd>h                 \ . command
086 equ s>t-cmnd>h               \ stack to target
087 equ s>h-cmnd>h               \ stack to host




\ status codes .. Jon 11/12/89
\

hex

0FF equ OK!             \ status codes
0FE equ ACK!            \
0FD equ ERROR!          \
0FC equ SUFL!		\ data stack underflow
0FB equ SOFL!		\ 	     overflow
0FA equ RUFL!		\ return stack underflow
0F9 equ ROFL!		\ 	       overflow
